/*

  EASYMOVE.DLL

  Loadmodule for Litestep shell (and hereby compatible clones)
  Copyright (C) 2001-2002 Pavel Vitis
  pavel.vitis@seznam.cz
  http://lsg.come.to/

  Programmed in LCC-WIN32 free C compiler/tools/IDE by Jacob Navia.
  Lcc-win32 compiler and accompanying tools may be obtained at:
  http://www.cs.virginia.edu/~lcc-win32/

  For another compilers some adjustments/corrections may be needed.


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <windows.h>
#include <string.h>
#include "lsapi.h"
#include "main.h"
#include "hookdll.h"
#include "../kmhook/hookdll.h"

HWND hLitestep = NULL;
HWND hDesktop = NULL;
DWORD OSVer;
HINSTANCE DLLInstance = NULL;

void BangEnable(HWND Caller, char *Args)
{
	config.enabled = TRUE;
}

void BangDisable(HWND Caller, char *Args)
{
	config.enabled = FALSE;
}

void BangToggle(HWND Caller, char *Args)
{
	config.enabled = !config.enabled;
}


__declspec( dllexport ) int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	OSVERSIONINFO osvinfo;

	// Get windows version
	osvinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if ( !GetVersionEx(&osvinfo) )
		return 1;
	OSVer = osvinfo.dwPlatformId;

	// Cache important window handles
	hLitestep = GetLitestepWnd();
	hDesktop = FindWindow("DesktopBackgroundClass", NULL);
	if (!hDesktop)
		hDesktop = GetDesktopWindow();

	DLLInstance = dllInst;
	steprcPath = strdup(szPath);

	// Create tool-window
	if ( !createToolWindow() )
	{
		return 1;
	}

	// Set variables
	if (!loadConfig())
		return 1;

/*
	// Initialize process-information retriever
	if ( !initProcessInfo() )
	{
		return 1;
	}
*/
	// Load system-wide hook library
	if ( !loadHookDLL( dllInst, NEED_HOOKDLL_VER ) )
	{
		return 1;
	}

	// Bang commands
	AddBangCommand("!EasyMoveEnable", &BangEnable);
	AddBangCommand("!EasyMoveDisable", &BangDisable);
	AddBangCommand("!EasyMoveToggle", &BangToggle);

	LOGF("Tool window HWND: #%x", ToolWindow);

	// Set mouse and keyboard hook

	hook_init();

	return 0;
}

__declspec( dllexport ) void quitModule(HINSTANCE dllInst)
{
/*
	if (LWinKey)
		{
//		KillTimer(hMainWnd, 1);
		UnregisterHotKey(ToolWindow, LWinKey);
		DeleteAtom(LWinKey);
		LWinKey = 0;
	}

	if (RWinKey)
	{
//		KillTimer(hMainWnd, 2);
		UnregisterHotKey(ToolWindow, RWinKey);
		DeleteAtom(RWinKey);
		RWinKey = 0;
	}
*/
	(unsetKeyboardHook)( ToolWindow );
	(unsetMouseHook)( ToolWindow );
	destroyToolWindow();

	RemoveBangCommand("!EasyMoveDisable");
	RemoveBangCommand("!EasyMoveEnable");
	RemoveBangCommand("!EasyMoveToggle");

	unloadHookDLL();

	freeConfig();
	if (steprcPath)
		free(steprcPath);

//	doneProcessInfo();
}

__declspec( dllexport ) int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, (wd)? wd->lsPath : NULL);
}


__declspec( dllexport ) BOOL WINAPI LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
	UNREFERENCED_PARAMETER(lpvReserved);

	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		LOG("DllMain called: DLL_PROCESS_ATTACH");
		DisableThreadLibraryCalls(hDLLInst);
	}
	return TRUE;
}
